<?php
/**
 * Х륵ȶͭؿե
 */

require_once DATA_PATH . 'module/Net/URL.php';
require_once DATA_PATH . 'class/SC_DbConn.php';
require_once DATA_PATH . 'class/SC_Query.php';

/**
 * EC-CUBE ݡȤüɤå롣
 * бüξ unsupported/index.php إ쥯Ȥ롣
 *
 * @return void
 */
function lfMobileCheckCompatibility() {
	if (!GC_MobileUserAgent::isSupported()) {
		header('Location: ' . URL_DIR . 'unsupported/index.php');
		exit;
	}
}

/**
 * ϥǡ󥳡ǥ󥰤Ѵʸ롣
 *
 * @param string &$value ϥǡؤλ
 * @return void
 */
function lfMobileConvertInputValue(&$value) {
	// Shift JIS 󥳡ǥ󥰤Ѵ롣
	// SoftBank ʳγʸϳΰ˴ޤޤ뤿ᡢʳǽ롣
	$value = mb_convert_encoding($value, CHAR_CODE, 'SJIS');

	// SoftBank γʸ롣
	$value = preg_replace('/\\x1b\\$[^\\x0f]*\\x0f/', '', $value);
}

/**
 * Х륵ѤϤνԤ
 *
 * @return void
 */
function lfMobileInitInput() {
	array_walk($_GET, 'lfMobileConvertInputValue');
	array_walk($_POST, 'lfMobileConvertInputValue');
	array_walk($_REQUEST, 'lfMobileConvertInputValue');
}

/**
 * dtb_mobile_ext_session_id ơ֥򸡺ƥåID롣
 *
 * @return string|null åID֤
 *                     Ǥʤä null ֤
 */
function lfMobileGetExtSessionId() {
	if (!preg_match('|^' . URL_DIR . '(.*)$|', $_SERVER['SCRIPT_NAME'], $matches)) {
		return null;
	}

	$url = $matches[1];
	$time = date('Y-m-d H:i:s', time() - MOBILE_SESSION_LIFETIME);
	$objQuery = new SC_Query;

	foreach ($_REQUEST as $key => $value) {
		$session_id = $objQuery->get('dtb_mobile_ext_session_id', 'session_id',
		                             'param_key = ? AND param_value = ? AND url = ? AND create_date >= ?',
		                             array($key, $value, $url, $time));
		if (isset($session_id)) {
			return $session_id;
		}
	}

	return null;
}

/**
 * ѥ᡼ͭʥåID롣
 *
 * @return string|false ͭʥåID֤
 *                      Ǥʤä false ֤
 */
function lfMobileGetSessionId() {
	// ѥ᡼饻åID롣
	$sessionId = @$_POST[session_name()];
	if (!isset($sessionId)) {
		$sessionId = @$_GET[session_name()];
	}
	if (!isset($sessionId)) {
		$sessionId = lfMobileGetExtSessionId();
	}
	if (!isset($sessionId)) {
		return false;
	}

	// åIDΥեޥåȤå롣
	if (preg_match('/^[0-9a-zA-Z,-]{32,}$/', $sessionId) < 1) {
		gfPrintLog("Invalid session id : sid=$sessionId");
		return false;
	}

	// åID¸ߤå롣
	if (sfSessRead($sessionId) === null) {
		gfPrintLog("Non-existent session id : sid=$sessionId");
		return false;
	}

	return session_id($sessionId);
}

/**
 * åǡͭɤå롣
 *
 * @return boolean åǡͭʾ true̵ʾ false ֤
 */
function lfMobileValidateSession() {
	//  mobile ϿƤ뤫ɤå롣
	if (!is_array(@$_SESSION['mobile'])) {
		return false;
	}

	// ͭ¤᤮Ƥʤɤå롣
	if (intval(@$_SESSION['mobile']['expires']) < time()) {
		gfPrintLog("Session expired at " .
		           date('Y/m/d H:i:s', @$_SESSION['mobile']['expires']) .
		           ' : sid=' . session_id());

		return false;
	}

	// üε郎פ뤫ɤå롣
	$model = GC_MobileUserAgent::getModel();
	if (@$_SESSION['mobile']['model'] != $model) {
		gfPrintLog("User agent model mismatch : " .
		           "\"$model\" != \"" . @$_SESSION['mobile']['model'] .
		           '" (expected), sid=' . session_id());
		return false;
	}

	return true;
}

/**
 * Х륵ѤΥåϢνԤ
 *
 * @return void
 */
function lfMobileInitSession() {
	// åIDμϤ˥åѤʤ
	ini_set('session.use_cookies', '0');

	// ѥ᡼ͭʥåID롣
	$sessionId = lfMobileGetSessionId();

	session_start();

	// åIDޤϥåǡ̵ʾϡåID
	// åǡ롣
	if ($sessionId === false || !lfMobileValidateSession()) {
		session_regenerate_id();
		$_SESSION = array('mobile' => array('model'    => GC_MobileUserAgent::getModel(),
		                                    'phone_id' => GC_MobileUserAgent::getId(),
		                                    'expires'  => time() + MOBILE_SESSION_LIFETIME));

		// åIDղäƥ쥯Ȥ롣
		if ($_SERVER['REQUEST_METHOD'] == 'GET') {
			// GET ξƱڡ˥쥯Ȥ롣
			header('Location: ' . gfAddSessionId());
		} else {
			// GET ʳξϥȥåץڡإ쥯Ȥ롣
			header('Location: ' . URL_SITE_TOP . '?' . SID);
		}
		exit;
	}

	// üIDǤϥåǡ¸롣
	$phoneId = GC_MobileUserAgent::getId();
	if ($phoneId !== false) {
		$_SESSION['mobile']['phone_id'] = $phoneId;
	}

	// åͭ¤򹹿롣
	$_SESSION['mobile']['expires'] = time() + MOBILE_SESSION_LIFETIME;
}

/**
 * Х륵ѤνϤνԤ
 *
 * Ϥή
 * 1. Smarty
 * 2. 󥳡ǥ󥰤 Shift JIS Ѵ롣
 * 3. ѥʤȾѥʤѴ롣
 * 4. ѤΥĴ롣
 * 5. ʸʸɤѴ롣
 * 6. 
 *
 * @return void
 */
function lfMobileInitOutput() {
	// Smarty ѤΥǥ쥯ȥ꡼롣
	@mkdir(COMPILE_DIR);

	// ѤΥ󥳡ǥ󥰤 Shift JIS ˸ꤹ롣
	mb_http_output('SJIS-win');

	// ʸʸɤѴ롣
	ob_start(array('GC_MobileEmoji', 'handler'));

	// ü˹碌ƲѴ롣
	ob_start(array('GC_MobileImage', 'handler'));

	// ѥʤȾѥʤѴ롣
	ob_start(create_function('$buffer', 'return mb_convert_kana($buffer, "k", "SJIS-win");'));

	// 󥳡ǥ󥰤 Shift JIS Ѵ롣
	ob_start('mb_output_handler');
}

/**
 * Х륵ѤνԤ
 *
 * @return void
 */
function sfMobileInit() {
	lfMobileInitInput();

	if (basename(dirname($_SERVER['SCRIPT_NAME'])) != 'unsupported') {
		lfMobileCheckCompatibility();
		lfMobileInitSession();
	}

	lfMobileInitOutput();
}

/**
 * LocationǥåIDղäɬפURL˥åIDղä롣
 *
 * @return String
 */
function gfAddSessionId($url = null) {
	$objURL = new Net_URL($url);
	$objURL->addQueryString(session_name(), session_id());
	return $objURL->getURL();
}

/**
 * ᡼ѤΥȡ롣
 *
 * @return string ȡ֤
 */
function lfGenerateKaraMailToken() {
	$token_chars = '0123456789abcdefghijklmnopqrstuvwxyz';
	$token_chars_length = strlen($token_chars);
	$token_length = 10;
	$token = '';

	while ($token_length > 0) {
		$token .= $token_chars{mt_rand(0, $token_chars_length - 1)};
		--$token_length;
	}

	return $token;
}

/**
 * ᡼ơ֥˿ȥ꡼Ͽȡ֤
 *
 * @param string $next_url ᡼դܤڡ (Х륵ȥȥåפURL)
 * @param string $session_id åID (άϸߤΥåID)
 * @return string|false ȡ֤顼ȯfalse֤
 */
function gfPrepareKaraMail($next_url, $session_id = null) {
	if (!isset($session_id)) {
		$session_id = session_id();
	}

	$objQuery = new SC_Query;

	// GC
	$time = date('Y-m-d H:i:s', time() - MOBILE_SESSION_LIFETIME);
	$objQuery->delete('dtb_mobile_kara_mail', 'email IS NULL AND create_date < ?', array($time));

	$objQuery->delete('dtb_mobile_kara_mail', 'session_id = ?', array($session_id));

	$arrValues = array('session_id' => $session_id,
	                   'next_url'   => $next_url);

	$try = 10;

	while ($try > 0) {
		$arrValues['token'] = $token = lfGenerateKaraMailToken();

		$objQuery->insert('dtb_mobile_kara_mail', $arrValues);
		$count = $objQuery->count('dtb_mobile_kara_mail', 'token = ?', array($token));

		if ($count == 1) {
			break;
		}

		$objQuery->delete('dtb_mobile_kara_mail', 'session_id = ?', array($session_id));
		$token = false;
		--$try;
	}

	return $token;
}

/**
 * ᡼뤫᡼륢ɥ쥹᡼ơ֥Ͽ롣
 *
 * @param string $token ȡ
 * @param string $email ᡼륢ɥ쥹
 * @return boolean trueԤfalse֤
 */
function gfRegisterKaraMail($token, $email) {
	$objQuery = new SC_Query;

	// GC
	$time = date('Y-m-d H:i:s', time() - MOBILE_SESSION_LIFETIME);
	$objQuery->delete('dtb_mobile_kara_mail',
	                  '(email IS NULL AND create_date < ?) OR (email IS NOT NULL AND receive_date < ?)',
	                  array($time, $time));

	$kara_mail_id = $objQuery->get('dtb_mobile_kara_mail', 'kara_mail_id', 'token = ?', array($token));
	if (!isset($kara_mail_id)) {
		return false;
	}

	$arrValues = array('email' => $email);
	$arrRawValues = array('receive_date' => 'now()');
	$objQuery->update('dtb_mobile_kara_mail', $arrValues, 'kara_mail_id = ?', array($kara_mail_id), $arrRawValues);

	return true;
}

/**
 * ᡼ơ֥뤫ȡ󤬰פԤ
 * ܤڡURL֤
 *
 * ᡼륢ɥ쥹 $_SESSION['mobile']['kara_mail_from'] Ͽ롣
 *
 * @param string $token ȡ
 * @return string|false URL֤顼ȯfalse֤
 */
function gfFinishKaraMail($token) {
	$objQuery = new SC_Query;

	$arrRow = $objQuery->getrow('dtb_mobile_kara_mail', 'session_id, next_url, email',
	                            'token = ? AND email IS NOT NULL AND receive_date >= ?',
	                            array($token, date('Y-m-d H:i:s', time() - MOBILE_SESSION_LIFETIME)));
	if (!isset($arrRow)) {
		return false;
	}

	$objQuery->delete('dtb_mobile_kara_mail', 'token = ?', array($token));

	list($session_id, $next_url, $email) = $arrRow;
	$objURL = new Net_URL(MOBILE_SITE_URL . $next_url);
	$objURL->addQueryString(session_name(), $session_id);
	$url = $objURL->getURL();

	session_id($session_id);
	session_start();
	$_SESSION['mobile']['kara_mail_from'] = $email;
	session_write_close();

	return $url;
}

/**
 * ϢѤ˥åIDȥѥ᡼Ȥ߹碌¸롣
 *
 * @param string $param_key ѥ᡼̾
 * @param string $param_value ѥ᡼
 * @param string $url URL
 * @return void
 */
function sfMobileSetExtSessionId($param_key, $param_value, $url) {
	$objQuery = new SC_Query;

	// GC
	$time = date('Y-m-d H:i:s', time() - MOBILE_SESSION_LIFETIME);
	$objQuery->delete('dtb_mobile_ext_session_id', 'create_date < ?', array($time));

	$arrValues = array('session_id'  => session_id(),
	                   'param_key'   => $param_key,
	                   'param_value' => $param_value,
	                   'url'         => $url);

	$objQuery->insert('dtb_mobile_ext_session_id', $arrValues);
}

/**
 * ᡼륢ɥ쥹ӤΤΤɤȽ̤롣
 *
 * @param string $address ᡼륢ɥ쥹
 * @return boolean ӤΥ᡼륢ɥ쥹ξtrueʳξfalse֤
 */
function gfIsMobileMailAddress($address) {
    // pdx.ne.jp(륳)ɲ
	$arrMobileMailDomains = array('docomo.ne.jp', 'ezweb.ne.jp', 'softbank.ne.jp', 'vodafone.ne.jp', 'pdx.ne.jp');

	if (defined('MOBILE_ADDITIONAL_MAIL_DOMAINS')) {
		$arrMobileMailDomains = array_merge($arrMobileMailDomains, split('[ ,]+', MOBILE_ADDITIONAL_MAIL_DOMAINS));
	}

	foreach ($arrMobileMailDomains as $domain) {
		$domain = str_replace('.', '\\.', $domain);
		if (preg_match("/@([^@]+\\.)?$domain\$/", $address)) {
			return true;
		}
	}

	return false;
}
?>
